module Language.VDM.SyntaxPP where
import Language.VDM.Syntax
import Language.VDM.TermInstances
import Text.PrettyPrint.HughesPJ hiding (Mode)
import GPP
import StrategyLib
 
instance PP Document where
	pp gpp (Document _0) = fsep [gppList gpp _0]
 
instance PP DefinitionBlock where
	pp gpp (DB_TypeDefinitions _0) = fsep [gpp _0]
	pp gpp (DB_StateDefinition _0) = fsep [gpp _0]
	pp gpp (DB_ValueDefinitions _0) = fsep [gpp _0]
	pp gpp (DB_FunctionDefinitions _0) = fsep [gpp _0]
	pp gpp (DB_OperationDefinitions _0) = fsep [gpp _0]
 
instance PP TypeDefinitions where
	pp gpp (TypeDefinitions _1)
	  = fsep [gpp "types", gppListSep gpp ";" _1]
 
instance PP TypeDefinition where
	pp gpp (UnTaggedTypeDef _0 _2 _3)
	  = fsep [gpp _0, gpp "=", gpp _2, gppMaybe gpp _3]
	pp gpp (TaggedTypeDef _0 _2 _3)
	  = fsep [gpp _0, gpp "::", gpp _2, gppMaybe gpp _3]
 
instance PP Type where
	pp gpp (BOOL) = fsep [gpp "bool"]
	pp gpp (NAT) = fsep [gpp "nat"]
	pp gpp (NATONE) = fsep [gpp "nat1"]
	pp gpp (INTEGER) = fsep [gpp "int"]
	pp gpp (RAT) = fsep [gpp "rat"]
	pp gpp (REAL) = fsep [gpp "real"]
	pp gpp (CHAR) = fsep [gpp "char"]
	pp gpp (TOKEN) = fsep [gpp "token"]
	pp gpp (QuoteType _0) = fsep [gpp _0]
	pp gpp (CompositeType _1 _3)
	  = fsep [gpp "compose", gpp _1, gpp "of", gpp _3, gpp "end"]
	pp gpp (UnionType _0 _2) = fsep [gpp _0, gpp "|", gpp _2]
	pp gpp (ProductType _0 _2) = fsep [gpp _0, gpp "*", gpp _2]
	pp gpp (OptionalType _1) = fsep [gpp "[", gpp _1, gpp "]"]
	pp gpp (SetType _2) = fsep [gpp "set", gpp "of", gpp _2]
	pp gpp (Seq0Type _2) = fsep [gpp "seq", gpp "of", gpp _2]
	pp gpp (Seq1Type _2) = fsep [gpp "seq1", gpp "of", gpp _2]
	pp gpp (GeneralMapType _1 _3)
	  = fsep [gpp "map", gpp _1, gpp "to", gpp _3]
	pp gpp (InjectiveMapType _1 _3)
	  = fsep [gpp "inmap", gpp _1, gpp "to", gpp _3]
	pp gpp (FnType _0) = fsep [gpp _0]
	pp gpp (TypeName _0) = fsep [gpp _0]
	pp gpp (TypeVar _0) = fsep [gpp _0]
 
instance PP FieldList where
	pp gpp (FieldList _0) = fsep [gppList gpp _0]
 
instance PP Field where
	pp gpp (Field _0 _1) = fsep [gppMaybe gpp _0, gpp _1]
 
instance PP FunctionType where
	pp gpp (PartialFnType _0 _2) = fsep [gpp _0, gpp "->", gpp _2]
	pp gpp (TotalFnType _0 _2) = fsep [gpp _0, gpp "-t>", gpp _2]
 
instance PP DiscretionaryType where
	pp gpp (DiscretionaryType _0) = fsep [gppEither gpp _0]
 
instance PP TypeVariableIdentifier where
	pp gpp (TypeVarId _1) = fsep [gpp "@", gpp _1]
 
instance PP Invariant where
	pp gpp (Invariant _1) = fsep [gpp "inv", gpp _1]
 
instance PP InvariantInitialFunction where
	pp gpp (InvInitFn _0 _2) = fsep [gpp _0, gpp "==", gpp _2]
 
instance PP StateDefinition where
	pp gpp (StateDef _1 _3 _4 _5)
	  = fsep
	      [gpp "state", gpp _1, gpp "of", gpp _3, gppMaybe gpp _4,
	       gppMaybe gpp _5, gpp "end"]
 
instance PP Initialization where
	pp gpp (Initialization _1) = fsep [gpp "init", gpp _1]
 
instance PP ValueDefinitions where
	pp gpp (ValueDefinitions _1)
	  = fsep [gpp "values", gppListSep gpp ";" _1]
 
instance PP ValueDefinition where
	pp gpp (ValueDef _0 _1 _3)
	  = fsep [gpp _0, gppMaybe gpp _1, gpp "=", gpp _3]
 
instance PP FunctionDefinitions where
	pp gpp (FunctionDefinitions _1)
	  = fsep [gpp "functions", gppListSep gpp ";" _1]
 
instance PP FunctionDefinition where
	pp gpp (ExplFnDef _0 _1 _3 _4 _5 _7 _8)
	  = fsep
	      [gpp _0, gppMaybe gpp _1, gpp ":", gpp _3, gpp _4, gpp _5,
	       gpp "==", gpp _7, gppMaybe gpp _8]
	pp gpp (ImplFnDef _0 _1 _2 _3 _4 _6)
	  = fsep
	      [gpp _0, gppMaybe gpp _1, gpp _2, gpp _3, gppMaybe gpp _4,
	       gpp "post", gpp _6]
 
instance PP TypeVariableList where
	pp gpp (TypeVarList _1)
	  = fsep [gpp "[", gppListSep gpp "," _1, gpp "]"]
 
instance PP IdentifierTypePair where
	pp gpp (IdType _0 _2) = fsep [gpp _0, gpp ":", gpp _2]
 
instance PP ParameterTypes where
	pp gpp (ParameterTypes _1)
	  = fsep [gpp "(", gppMaybe gpp _1, gpp ")"]
 
instance PP PatternTypePairList where
	pp gpp (PatTypePairList _0) = fsep [gppListSep gpp "," _0]
 
instance PP PatternTypePair where
	pp gpp (PatTypePair _0 _2) = fsep [gpp _0, gpp ":", gpp _2]
 
instance PP ParametersList where
	pp gpp (ParametersList _0) = fsep [gppList gpp _0]
 
instance PP Parameters where
	pp gpp (Parameters _1) = fsep [gpp "(", gppMaybe gpp _1, gpp ")"]
 
instance PP OperationDefinitions where
	pp gpp (OperationDefinitions _1)
	  = fsep [gpp "operations", gppListSep gpp ";" _1]
 
instance PP OperationDefinition where
	pp gpp (ExplOprtDef _0 _2 _3 _4 _6 _7)
	  = fsep
	      [gpp _0, gpp ":", gpp _2, gpp _3, gpp _4, gpp "==", gpp _6,
	       gppMaybe gpp _7]
	pp gpp (ImplOprtDef _0 _1 _2 _3 _4 _6 _7)
	  = fsep
	      [gpp _0, gpp _1, gppMaybe gpp _2, gppMaybe gpp _3, gppMaybe gpp _4,
	       gpp "post", gpp _6, gppMaybe gpp _7]
 
instance PP OperationType where
	pp gpp (OpType _0 _2) = fsep [gpp _0, gpp "==>", gpp _2]
 
instance PP Externals where
	pp gpp (Externals _1) = fsep [gpp "ext", gppList gpp _1]
 
instance PP VarInformation where
	pp gpp (VarInf _0 _1 _2) = fsep [gpp _0, gpp _1, gppMaybe gpp _2]
 
instance PP Mode where
	pp gpp (READ) = fsep [gpp "rd"]
	pp gpp (READWRITE) = fsep [gpp "wr"]
 
instance PP Exceptions where
	pp gpp (Exceptions _1) = fsep [gpp "errs", gppList gpp _1]
 
instance PP Error where
	pp gpp (Error _0 _2 _4)
	  = fsep [gpp _0, gpp ":", gpp _2, gpp "->", gpp _4]
 
instance PP ExpressionList where
	pp gpp (ExprList _0) = fsep [gppListSep gpp "," _0]
 
instance PP Expression where
	pp gpp (LetExpr _1 _3)
	  = fsep [gpp "let", gppListSep gpp "," _1, gpp "in", gpp _3]
	pp gpp (LetBeSTExpr _1 _2 _4)
	  = fsep [gpp "let", gpp _1, gppMaybe gpp _2, gpp "in", gpp _4]
	pp gpp (DefExpr _1 _3)
	  = fsep [gpp "def", gppListSep gpp ";" _1, gpp "in", gpp _3]
	pp gpp (IfExpr _1 _3 _4 _6)
	  = fsep
	      [gpp "if", gpp _1, gpp "then", gpp _3, gppList gpp _4, gpp "else",
	       gpp _6]
	pp gpp (CasesExpr _1 _3 _4)
	  = fsep
	      [gpp "cases", gpp _1, gpp ":", gpp _3, gppMaybe gpp _4, gpp "end"]
	pp gpp (UnaryNumPlusExpr _1) = fsep [gpp "+", gpp _1]
	pp gpp (UnaryNumMinusExpr _1) = fsep [gpp "-", gpp _1]
	pp gpp (NumAbsExpr _1) = fsep [gpp "abs", gpp _1]
	pp gpp (FloorExpr _1) = fsep [gpp "floor", gpp _1]
	pp gpp (NotExpr _1) = fsep [gpp "not", gpp _1]
	pp gpp (SetCardExpr _1) = fsep [gpp "card", gpp _1]
	pp gpp (SetPowerExpr _1) = fsep [gpp "power", gpp _1]
	pp gpp (SetDistrUnionExpr _1) = fsep [gpp "dunion", gpp _1]
	pp gpp (SetDistrIntersectExpr _1) = fsep [gpp "dinter", gpp _1]
	pp gpp (SeqHeadExpr _1) = fsep [gpp "hd", gpp _1]
	pp gpp (SeqTailExpr _1) = fsep [gpp "tl", gpp _1]
	pp gpp (SeqLenExpr _1) = fsep [gpp "len", gpp _1]
	pp gpp (SeqElemsExpr _1) = fsep [gpp "elems", gpp _1]
	pp gpp (SeqIndicesExpr _1) = fsep [gpp "inds", gpp _1]
	pp gpp (SeqDistrConcExpr _1) = fsep [gpp "conc", gpp _1]
	pp gpp (MapDomExpr _1) = fsep [gpp "dom", gpp _1]
	pp gpp (MapRngExpr _1) = fsep [gpp "rng", gpp _1]
	pp gpp (MapDistrMergeExpr _1) = fsep [gpp "merge", gpp _1]
	pp gpp (MapInverseExpr _1) = fsep [gpp "inverse", gpp _1]
	pp gpp (BinaryNumPlusExpr _0 _2) = fsep [gpp _0, gpp "+", gpp _2]
	pp gpp (BinaryNumMinusExpr _0 _2) = fsep [gpp _0, gpp "-", gpp _2]
	pp gpp (NumPlusExpr _0 _2) = fsep [gpp _0, gpp "*", gpp _2]
	pp gpp (NumDivExpr _0 _2) = fsep [gpp _0, gpp "/", gpp _2]
	pp gpp (IntDivExpr _0 _2) = fsep [gpp _0, gpp "div", gpp _2]
	pp gpp (NumRemExpr _0 _2) = fsep [gpp _0, gpp "rem", gpp _2]
	pp gpp (NumModExpr _0 _2) = fsep [gpp _0, gpp "mod", gpp _2]
	pp gpp (NumLtExpr _0 _2) = fsep [gpp _0, gpp "<", gpp _2]
	pp gpp (NumLeExpr _0 _2) = fsep [gpp _0, gpp "<=", gpp _2]
	pp gpp (NumGtExpr _0 _2) = fsep [gpp _0, gpp ">", gpp _2]
	pp gpp (NumGeExpr _0 _2) = fsep [gpp _0, gpp ">=", gpp _2]
	pp gpp (EqExpr _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
	pp gpp (NeExpr _0 _2) = fsep [gpp _0, gpp "<>", gpp _2]
	pp gpp (OrExpr _0 _2) = fsep [gpp _0, gpp "or", gpp _2]
	pp gpp (AndExpr _0 _2) = fsep [gpp _0, gpp "and", gpp _2]
	pp gpp (ImplyExpr _0 _2) = fsep [gpp _0, gpp "=>", gpp _2]
	pp gpp (EquivExpr _0 _2) = fsep [gpp _0, gpp "<=>", gpp _2]
	pp gpp (InSetExpr _0 _2)
	  = fsep [gpp _0, fsep [gpp "in", gpp "set"], gpp _2]
	pp gpp (NotInSetExpr _0 _2)
	  = fsep [gpp _0, fsep [gpp "not", gpp "in", gpp "set"], gpp _2]
	pp gpp (SubsetExpr _0 _2) = fsep [gpp _0, gpp "subset", gpp _2]
	pp gpp (ProperSubsetExpr _0 _2)
	  = fsep [gpp _0, gpp "psubset", gpp _2]
	pp gpp (SetUnionExpr _0 _2) = fsep [gpp _0, gpp "union", gpp _2]
	pp gpp (SetDifference _0 _2) = fsep [gpp _0, gpp "\\\\", gpp _2]
	pp gpp (SetIntersect _0 _2) = fsep [gpp _0, gpp "inter", gpp _2]
	pp gpp (SeqConc _0 _2) = fsep [gpp _0, gpp "^", gpp _2]
	pp gpp (MapOrSeqModExpr _0 _2) = fsep [gpp _0, gpp "++", gpp _2]
	pp gpp (MapMergeExpr _0 _2) = fsep [gpp _0, gpp "munion", gpp _2]
	pp gpp (MapDomRestrToExpr _0 _2) = fsep [gpp _0, gpp "<:", gpp _2]
	pp gpp (MapDomRestrByExpr _0 _2) = fsep [gpp _0, gpp "<-:", gpp _2]
	pp gpp (MapRngRestrToExpr _0 _2) = fsep [gpp _0, gpp ":>", gpp _2]
	pp gpp (MapRngRestrByExpr _0 _2) = fsep [gpp _0, gpp ":->", gpp _2]
	pp gpp (ComposeExpr _0 _2) = fsep [gpp _0, gpp "comp", gpp _2]
	pp gpp (IterateExpr _0 _2) = fsep [gpp _0, gpp "**", gpp _2]
	pp gpp (QuantExpr _0) = fsep [gpp _0]
	pp gpp (IotaExpr _1 _3)
	  = fsep [gpp "iota", gpp _1, gpp "&", gpp _3]
	pp gpp (SetEnumeration _1)
	  = fsep [gpp "{", gppMaybe gpp _1, gpp "}"]
	pp gpp (SetComprehension _1 _3 _4)
	  = fsep [gpp "{", gpp _1, gpp "|", gpp _3, gppMaybe gpp _4, gpp "}"]
	pp gpp (SetRange _1 _5)
	  = fsep
	      [gpp "{", gpp _1, gpp ",", gpp "...", gpp ",", gpp _5, gpp "}"]
	pp gpp (SeqEnumeration _1)
	  = fsep [gpp "[", gppMaybe gpp _1, gpp "]"]
	pp gpp (SeqComprehension _1 _3 _4)
	  = fsep [gpp "[", gpp _1, gpp "|", gpp _3, gppMaybe gpp _4, gpp "]"]
	pp gpp (SubSequence _0 _2 _6)
	  = fsep
	      [gpp _0, gpp "(", gpp _2, gpp ",", gpp "...", gpp ",", gpp _6,
	       gpp ")"]
	pp gpp (MapEnumeration _0) = fsep [gppEither gpp _0]
	pp gpp (MapComprehension _1 _3 _4)
	  = fsep [gpp "{", gpp _1, gpp "|", gpp _3, gppMaybe gpp _4, gpp "}"]
	pp gpp (TupleConstructor _2 _4)
	  = fsep [gpp "mk_", gpp "(", gpp _2, gpp ",", gpp _4, gpp ")"]
	pp gpp (RecordConstructor _1 _3)
	  = fsep [gpp "mk_", gpp _1, gpp "(", gppMaybe gpp _3, gpp ")"]
	pp gpp (RecordModifier _2 _4)
	  = fsep
	      [gpp "mu", gpp "(", gpp _2, gpp ",", gppListSep gpp "," _4,
	       gpp ")"]
	pp gpp (Apply _0 _2)
	  = fsep [gpp _0, gpp "(", gppMaybe gpp _2, gpp ")"]
	pp gpp (FieldSelect _0 _2) = fsep [gpp _0, gpp ".", gpp _2]
	pp gpp (FctTypeInst _0 _2)
	  = fsep [gpp _0, gpp "[", gppListSep gpp "," _2, gpp "]"]
	pp gpp (Lambda _1 _3)
	  = fsep [gpp "lambda", gpp _1, gpp "&", gpp _3]
	pp gpp (IsBoolExpr _3)
	  = fsep [gpp "is_", gpp "bool", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsNatExpr _3)
	  = fsep [gpp "is_", gpp "nat", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsNatOneExpr _3)
	  = fsep [gpp "is_", gpp "nat1", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsIntegerExpr _3)
	  = fsep [gpp "is_", gpp "int", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsRatExpr _3)
	  = fsep [gpp "is_", gpp "rat", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsRealExpr _3)
	  = fsep [gpp "is_", gpp "real", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsCharExpr _3)
	  = fsep [gpp "is_", gpp "char", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsTokenExpr _3)
	  = fsep [gpp "is_", gpp "token", gpp "(", gpp _3, gpp ")"]
	pp gpp (IsDefTypeExpr _1 _3)
	  = fsep [gpp "is_", gpp _1, gpp "(", gpp _3, gpp ")"]
	pp gpp (NameExpr _0) = fsep [gpp _0]
	pp gpp (OldNameExpr _0) = fsep [gpp _0]
	pp gpp (LiteralExpr _0) = fsep [gpp _0]
 
instance PP DefBind where
	pp gpp (DefBind _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
 
instance PP ElseIfExpression where
	pp gpp (ElsifExpr _1 _3)
	  = fsep [gpp "elseif", gpp _1, gpp "then", gpp _3]
 
instance PP CasesExpressionAlternatives where
	pp gpp (CasesExprAlternatives _0) = fsep [gppListSep gpp "," _0]
 
instance PP CasesExpressionAlternative where
	pp gpp (CaseAltn _0 _2) = fsep [gpp _0, gpp "->", gpp _2]
 
instance PP OthersExpression where
	pp gpp (OthersExpr _2) = fsep [gpp "others", gpp "->", gpp _2]
 
instance PP QuantifiedExpression where
	pp gpp (AllExpr _1 _3)
	  = fsep [gpp "forall", gpp _1, gpp "&", gpp _3]
	pp gpp (ExistsExpr _1 _3)
	  = fsep [gpp "exists", gpp _1, gpp "&", gpp _3]
	pp gpp (ExistsUniqueExpr _1 _3)
	  = fsep [gpp "exists1", gpp _1, gpp "&", gpp _3]
 
instance PP Maplet where
	pp gpp (Maplet _0 _2) = fsep [gpp _0, gpp "|->", gpp _2]
 
instance PP RecordModification where
	pp gpp (RecordModification _0 _2)
	  = fsep [gpp _0, gpp "|->", gpp _2]
 
instance PP Name where
	pp gpp (Name _0) = fsep [gpp _0]
 
instance PP NameList where
	pp gpp (NameList _0) = fsep [gppListSep gpp "," _0]
 
instance PP OldName where
	pp gpp (OldName _0) = fsep [gpp _0, gpp "~"]
 
instance PP StateDesignator where
	pp gpp (StDesignatorName _0) = fsep [gpp _0]
	pp gpp (FieldRef _0 _2) = fsep [gpp _0, gpp ".", gpp _2]
	pp gpp (MapOrSeqRef _0 _2)
	  = fsep [gpp _0, gpp "(", gpp _2, gpp ")"]
 
instance PP Statement where
	pp gpp (LetStmt _1 _3)
	  = fsep [gpp "let", gppListSep gpp "," _1, gpp "in", gpp _3]
	pp gpp (LetBeSTStmt _1 _2 _4)
	  = fsep [gpp "let", gpp _1, gppMaybe gpp _2, gpp "in", gpp _4]
	pp gpp (DefStmt _1 _3)
	  = fsep [gpp "def", gppListSep gpp ";" _1, gpp "in", gpp _3]
	pp gpp (BlockStmt _1 _2)
	  = fsep [gpp "(", gppList gpp _1, gppListSep gpp ";" _2, gpp ")"]
	pp gpp (AssignStmt _0) = fsep [gpp _0]
	pp gpp (IfStmt _1 _3 _4 _5)
	  = fsep
	      [gpp "if", gpp _1, gpp "then", gpp _3, gppList gpp _4,
	       gppMaybe gpp _5]
	pp gpp (CasesStmt _1 _3 _4)
	  = fsep
	      [gpp "cases", gpp _1, gpp ":", gpp _3, gppMaybe gpp _4, gpp "end"]
	pp gpp (SeqForLoop _1 _3 _4 _6)
	  = fsep
	      [gpp "for", gpp _1, gpp "in", gppMaybe gpp _3, gpp _4, gpp "do",
	       gpp _6]
	pp gpp (SetForLoop _2 _5 _7)
	  = fsep
	      [gpp "for", gpp "all", gpp _2, gpp "in", gpp "set", gpp _5,
	       gpp "do", gpp _7]
	pp gpp (IndexForLoop _1 _3 _5 _6 _8)
	  = fsep
	      [gpp "for", gpp _1, gpp "=", gpp _3, gpp "to", gpp _5,
	       gppMaybe gpp _6, gpp "do", gpp _8]
	pp gpp (WhileLoop _1 _3)
	  = fsep [gpp "while", gpp _1, gpp "do", gpp _3]
	pp gpp (NonDetStmt _2)
	  = fsep [gpp "||", gpp "(", gppListSep gpp "," _2, gpp ")"]
	pp gpp (CallStmt _0) = fsep [gpp _0]
	pp gpp (ReturnStmt _1) = fsep [gpp "return", gppMaybe gpp _1]
	pp gpp (AlwaysStmt _1 _3)
	  = fsep [gpp "always", gpp _1, gpp "in", gpp _3]
	pp gpp (TrapStmt _1 _3 _5)
	  = fsep [gpp "trap", gpp _1, gpp "with", gpp _3, gpp "in", gpp _5]
	pp gpp (RecTrapStmt _1 _3)
	  = fsep [gpp "tixe", gpp _1, gpp "in", gpp _3]
	pp gpp (ExitStmt _1) = fsep [gpp "exit", gppMaybe gpp _1]
	pp gpp (IdentStmt) = fsep [gpp "skip"]
 
instance PP LocalDefinition where
	pp gpp (LocalDefinition _0) = fsep [gppEither gpp _0]
 
instance PP EqualsDefinition where
	pp gpp (EqualsExprDef _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
	pp gpp (EqualsCallStmtDef _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
 
instance PP DclStatement where
	pp gpp (DclStmt _1) = fsep [gpp "dcl", gpp _1, gpp ";"]
 
instance PP AssignmentDefinition where
	pp gpp (AssignDefExpr _0 _2 _3)
	  = fsep [gpp _0, gpp ":", gpp _2, gppMaybe gpp _3]
	pp gpp (AssignDefCallStmt _0 _2 _3)
	  = fsep [gpp _0, gpp ":", gpp _2, gppMaybe gpp _3]
 
instance PP AssignStatement where
	pp gpp (AssignStmtExpr _0 _2) = fsep [gpp _0, gpp ":=", gpp _2]
	pp gpp (AssignStmtCallStmt _0 _2) = fsep [gpp _0, gpp ":=", gpp _2]
 
instance PP ElseifStatement where
	pp gpp (ElsifStmt _1 _3)
	  = fsep [gpp "elseif", gpp _1, gpp "then", gpp _3]
 
instance PP CasesStatementAlternatives where
	pp gpp (CasesStmtAlternatives _0) = fsep [gppListSep gpp "," _0]
 
instance PP CasesStatementAlternative where
	pp gpp (CasesStmtAltn _0 _2) = fsep [gpp _0, gpp "->", gpp _2]
 
instance PP OthersStatement where
	pp gpp (OthersStmt _2) = fsep [gpp "others", gpp "->", gpp _2]
 
instance PP CallStatement where
	pp gpp (Call _0 _2 _4)
	  = fsep [gpp _0, gpp "(", gppMaybe gpp _2, gpp ")", gppMaybe gpp _4]
 
instance PP Traps where
	pp gpp (Traps _1) = fsep [gpp "{", gppListSep gpp "," _1, gpp "}"]
 
instance PP Trap where
	pp gpp (Trap _0 _2) = fsep [gpp _0, gpp "|->", gpp _2]
 
instance PP Pattern where
	pp gpp (PatternId _0) = fsep [gppEither gpp _0]
	pp gpp (MatchValueExpr _1) = fsep [gpp "(", gpp _1, gpp ")"]
	pp gpp (MatchValueSymb _0) = fsep [gpp _0]
	pp gpp (SetEnumPattern _1) = fsep [gpp "{", gpp _1, gpp "}"]
	pp gpp (SetUnionPattern _0 _2) = fsep [gpp _0, gpp "union", gpp _2]
	pp gpp (SeqEnumPattern _1) = fsep [gpp "[", gpp _1, gpp "]"]
	pp gpp (SeqConcPattern _0 _2) = fsep [gpp _0, gpp "^", gpp _2]
	pp gpp (TuplePattern _2 _4)
	  = fsep [gpp "mk_", gpp "(", gpp _2, gpp ",", gpp _4, gpp ")"]
	pp gpp (RecordPattern _1 _3)
	  = fsep [gpp "mk_", gpp _1, gpp "(", gppMaybe gpp _3, gpp ")"]
 
instance PP PatternList where
	pp gpp (PatList _0) = fsep [gppListSep gpp "," _0]
 
instance PP PatternBind where
	pp gpp (PatternBind _0) = fsep [gppEither gpp _0]
 
instance PP Bind where
	pp gpp (Bind _0) = fsep [gppEither gpp _0]
 
instance PP SetBind where
	pp gpp (SetBind _0 _3) = fsep [gpp _0, gpp "in", gpp "set", gpp _3]
 
instance PP TypeBind where
	pp gpp (TypeBind _0 _2) = fsep [gpp _0, gpp ":", gpp _2]
 
instance PP BindList where
	pp gpp (BindList _0) = fsep [gppListSep gpp "," _0]
 
instance PP MultipleBind where
	pp gpp (MultSetBind _0 _3)
	  = fsep [gpp _0, gpp "in", gpp "set", gpp _3]
	pp gpp (MultTypeBind _0 _2) = fsep [gpp _0, gpp ":", gpp _2]
 
instance PP TypeBindList where
	pp gpp (TypeBindList _0) = fsep [gppListSep gpp "," _0]
 
instance PP SymbolicLiteral where
	pp gpp (NumericLiteral _0) = fsep [gpp _0]
	pp gpp (BooleanLiteral _0) = fsep [gpp _0]
	pp gpp (NilLiteral) = fsep [gpp "nil"]
	pp gpp (CharacterLiteral _0) = fsep [gpp _0]
	pp gpp (TextLiteral _0) = fsep [gpp _0]
	pp gpp (QuoteLiteral _0) = fsep [gpp _0]
 
instance PP BooleanLiteral where
	pp gpp (TRUE) = fsep [gpp "true"]
	pp gpp (FALSE) = fsep [gpp "false"]
 
uppSyntax :: UPP
uppSyntax gpp
  = (constTU empty) `adhocQ` (pp gpp :: MonoPP String) `adhocQ`
      (pp gpp :: MonoPP Document)
      `adhocQ` (pp gpp :: MonoPP DefinitionBlock)
      `adhocQ` (pp gpp :: MonoPP TypeDefinitions)
      `adhocQ` (pp gpp :: MonoPP TypeDefinition)
      `adhocQ` (pp gpp :: MonoPP Type)
      `adhocQ` (pp gpp :: MonoPP FieldList)
      `adhocQ` (pp gpp :: MonoPP Field)
      `adhocQ` (pp gpp :: MonoPP FunctionType)
      `adhocQ` (pp gpp :: MonoPP DiscretionaryType)
      `adhocQ` (pp gpp :: MonoPP TypeVariableIdentifier)
      `adhocQ` (pp gpp :: MonoPP Invariant)
      `adhocQ` (pp gpp :: MonoPP InvariantInitialFunction)
      `adhocQ` (pp gpp :: MonoPP StateDefinition)
      `adhocQ` (pp gpp :: MonoPP Initialization)
      `adhocQ` (pp gpp :: MonoPP ValueDefinitions)
      `adhocQ` (pp gpp :: MonoPP ValueDefinition)
      `adhocQ` (pp gpp :: MonoPP FunctionDefinitions)
      `adhocQ` (pp gpp :: MonoPP FunctionDefinition)
      `adhocQ` (pp gpp :: MonoPP TypeVariableList)
      `adhocQ` (pp gpp :: MonoPP IdentifierTypePair)
      `adhocQ` (pp gpp :: MonoPP ParameterTypes)
      `adhocQ` (pp gpp :: MonoPP PatternTypePairList)
      `adhocQ` (pp gpp :: MonoPP PatternTypePair)
      `adhocQ` (pp gpp :: MonoPP ParametersList)
      `adhocQ` (pp gpp :: MonoPP Parameters)
      `adhocQ` (pp gpp :: MonoPP OperationDefinitions)
      `adhocQ` (pp gpp :: MonoPP OperationDefinition)
      `adhocQ` (pp gpp :: MonoPP OperationType)
      `adhocQ` (pp gpp :: MonoPP Externals)
      `adhocQ` (pp gpp :: MonoPP VarInformation)
      `adhocQ` (pp gpp :: MonoPP Mode)
      `adhocQ` (pp gpp :: MonoPP Exceptions)
      `adhocQ` (pp gpp :: MonoPP Error)
      `adhocQ` (pp gpp :: MonoPP ExpressionList)
      `adhocQ` (pp gpp :: MonoPP Expression)
      `adhocQ` (pp gpp :: MonoPP DefBind)
      `adhocQ` (pp gpp :: MonoPP ElseIfExpression)
      `adhocQ` (pp gpp :: MonoPP CasesExpressionAlternatives)
      `adhocQ` (pp gpp :: MonoPP CasesExpressionAlternative)
      `adhocQ` (pp gpp :: MonoPP OthersExpression)
      `adhocQ` (pp gpp :: MonoPP QuantifiedExpression)
      `adhocQ` (pp gpp :: MonoPP Maplet)
      `adhocQ` (pp gpp :: MonoPP RecordModification)
      `adhocQ` (pp gpp :: MonoPP Name)
      `adhocQ` (pp gpp :: MonoPP NameList)
      `adhocQ` (pp gpp :: MonoPP OldName)
      `adhocQ` (pp gpp :: MonoPP StateDesignator)
      `adhocQ` (pp gpp :: MonoPP Statement)
      `adhocQ` (pp gpp :: MonoPP LocalDefinition)
      `adhocQ` (pp gpp :: MonoPP EqualsDefinition)
      `adhocQ` (pp gpp :: MonoPP DclStatement)
      `adhocQ` (pp gpp :: MonoPP AssignmentDefinition)
      `adhocQ` (pp gpp :: MonoPP AssignStatement)
      `adhocQ` (pp gpp :: MonoPP ElseifStatement)
      `adhocQ` (pp gpp :: MonoPP CasesStatementAlternatives)
      `adhocQ` (pp gpp :: MonoPP CasesStatementAlternative)
      `adhocQ` (pp gpp :: MonoPP OthersStatement)
      `adhocQ` (pp gpp :: MonoPP CallStatement)
      `adhocQ` (pp gpp :: MonoPP Traps)
      `adhocQ` (pp gpp :: MonoPP Trap)
      `adhocQ` (pp gpp :: MonoPP Pattern)
      `adhocQ` (pp gpp :: MonoPP PatternList)
      `adhocQ` (pp gpp :: MonoPP PatternBind)
      `adhocQ` (pp gpp :: MonoPP Bind)
      `adhocQ` (pp gpp :: MonoPP SetBind)
      `adhocQ` (pp gpp :: MonoPP TypeBind)
      `adhocQ` (pp gpp :: MonoPP BindList)
      `adhocQ` (pp gpp :: MonoPP MultipleBind)
      `adhocQ` (pp gpp :: MonoPP TypeBindList)
      `adhocQ` (pp gpp :: MonoPP SymbolicLiteral)
      `adhocQ` (pp gpp :: MonoPP BooleanLiteral)
      `adhocQ` (pp gpp :: MonoPP Identifier)
